REGISTER_X64 = {
    'al': '000', 'ax': '000', 'eax': '000', 'rax': '000',
    'cl': '001', 'cx': '001', 'ecx': '001', 'rcx': '001',
    'dl': '010', 'dx': '010', 'edx': '010', 'rdx': '010',
    'bl': '011', 'bx': '011', 'ebx': '011', 'rbx': '011',
    'ah': '100', 'sp': '100', 'esp': '100', 'rsp': '100',
    'ch': '101', 'bp': '101', 'ebp': '101', 'rbp': '101',
    'dh': '110', 'si': '110', 'esi': '110', 'rsi': '110',
    'bh': '111', 'di': '111', 'edi': '111', 'rdi': '111',
    'r8w': '000', 'r8d': '000', 'r8': '000',
    'r9w': '001', 'r9d': '001', 'r9': '001',
    'r10w': '010', 'r10d': '010', 'r10': '010',
    'r11w': '011', 'r11d': '011', 'r11': '011',
    'r12w': '100', 'r12d': '100', 'r12': '100',
    'r13w': '101', 'r13d': '101', 'r13': '101',
    'r14w': '110', 'r14d': '110', 'r14': '110',
    'r15w': '111', 'r15d': '111', 'r15': '111'
}

REGITER_8_BIT = ['al', 'bl', 'cl', 'dl', 'ah', 'bh', 'ch', 'dh']

REGISTER_16_BIT = ['ax', 'bx', 'cx', 'dx', 'sp', 'bp', 'si', 'di']

REGISTER_32_BIT = ['eax', 'ebx', 'ecx', 'edx', 'esp', 'ebp', 'esi', 'edi']

REGISTER_64_BIT = ['rax', 'rbx', 'rcx', 'rdx', 'rsp', 'rbp', 'rsi', 'rdi']

REGISTER_16_32_BIT = ['ax', 'bx', 'cx', 'dx', 'sp', 'bp', 'si', 'di',
                      'eax', 'ebx', 'ecx', 'edx', 'esp', 'ebp', 'esi', 'edi']

NEW_REGISTER_64 = ['r' + str(num) + x for num in range(8, 16) for x in ['', 'd', 'w']]

REGISTER_BP = ['ch', 'bp', 'ebp', 'rbp']

SCALE = {
    '': '00',
    '1': '00',
    '2': '01',
    '4': '10',
    '8': '11'
}
OPCODE = {
    'mov': {'rr': '10001001', 'ri': '11000111', 'reg_code': '000', 'rm': '10001011'},
    'add': {'rr': '00000001', 'ri': '10000001', 'reg_code': '000', 'rm': '00000011'},
    'or': {'rr': '00001001', 'ri': '10000001', 'reg_code': '001', 'rm': '00001011'},
    'adc': {'rr': '00010001', 'ri': '10000001', 'reg_code': '010', 'rm': '00010011'},
    'sbb': {'rr': '00011001', 'ri': '10000001', 'reg_code': '011', 'rm': '00011011'},
    'and': {'rr': '00100001', 'ri': '10000001', 'reg_code': '100', 'rm': '00100011'},
    'sub': {'rr': '00101001', 'ri': '10000001', 'reg_code': '101', 'rm': '00101011'},
    'xor': {'rr': '00111001', 'ri': '10000001', 'reg_code': '110', 'rm': '00110011'},
    'cmp': {'rr': '00111001', 'ri': '10000001', 'reg_code': '111', 'rm': '00111011'},
    'stc': '11111001',
    'clc': '11111000',
    'std': '11111101',
    'cld': '11111100',
    'syscall': '0000111100000101',
    'inc': {'r': '11111111', 'reg_code': '000'},
    'dec': {'r': '11111111', 'reg_code': '001'},
    'neg': {'r': '11110111', 'reg_code': '011'}
}
